config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users

##############################################################################



  #####################
  #####################
  ##   APPLICATION   ##
  #####################
  #####################

  get 'ping' => 'table_tennis#ping'
  get 'ping_api' => 'table_tennis#ping_api'

  get 'help' => 'help#index'

  
  ################
  #   Accueils   #
  ################
  root "home#index"
  get "home", to: "home#index"
  get "admin", to: "home#admin"


  ###################
  #   Maintenances  #
  ###################
  resources :maintenance_ressources
  resources :maintenances
  get "grille_maintenances", to: "maintenances#grille"

  
  #############
  #   Tools   #
  #############
  get "tools", to: "tools#index"
  get "check_days", to: "tools#check_days"
  get "check_users", to: "tools#check_users"
  get "check_admins", to: "tools#check_admins"
  get "backup_db", to: "tools#backup_db"
  get "exports", to: "tools#exports"
  get "download_backup", to: "tools#download_backup"
  get "statistics", to: "tools#statistics"

  get "calculate", to: "tools#calculate"


  ####################
  #   Configuration  #
  ####################
  resources :konfigurations, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##############
  #   Ajouts   #
  ##############
  resources :ajouts, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "ajouts/:id/valider", to: "ajouts#valider"
  get "ajouts/:id/dupliquer", to: "ajouts#dupliquer"
  get "ajouts/:id/modification", to: "ajouts#modification"


  ################
  #   Template   #
  ################
  resources :templates, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ##############
  #   Groupes  #
  ##############
  resources :groupes, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##############
  #   Classes  #
  ##############
  resources :classes, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###############
  #   Services  #
  ###############
  resources :services, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###############
  #   messages  #
  ###############
  resources :messages, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###########
  #  Lieux  #
  ###########
  resources :lieus, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##################
  #  Bug Repports  #
  ##################
  resources :bug_repports, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###################
  #  Blog Messages  #
  ###################
  resources :blog_messages, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  resources :blog_responses, only: [ :new, :edit, :create, :update, :destroy ]
  resources :reviewcats, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  get "blog_message_export_pdf", to: "export#blog_message_export_pdf"
  get "review_blog_message", to: "blog_messages#review"

  ################
  #  Wiki Pages  #
  ################
  resources :wiki_pages, only: [ :show, :index, :new, :edit, :create, :update, :destroy]

  #############
  #  Postits  #
  #############
  resources :postits, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  get "take_it", to: "postits#take_it"
  get "done", to: "postits#done"

  #####################
  #  Blog Categories  #
  #####################
  resources :blog_categories, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###################
  #   Utilisateurs  #
  ###################
  resources :utilisateurs, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  #######################
  #  Absences & Congés  #
  #######################
  resources :absences, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "grille", to: "absences#grille"
  get "not_yet_validated_absences", to: "absences#not_yet_validated"
  get "validated_absences", to: "absences#validated"
  get "remove_one_day", to: "absences#remove_one_day"


  ################
  #  Fermetures  #
  ################
  resources :fermetures, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ############
  #  Events  #
  ############
  resources :events, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##########
  #  Logs  #
  ##########
  resources :logs, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  resources :log_repports, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]

  
  #####################
  #   Types Absences  #
  #####################
  resources :type_absences, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Jours  #
  ############
  resources :jours, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "today", to: "jours#specific_day"
  get "week", to: "jours#specific_week"
  get "month", to: "jours#specific_month"
  get "secr_pet", to: "jours#secr_pet"
  get "ical_export_ics", to: "export#ical_export_ics"


  ###################
  #   WorkingLists  #
  ###################
  resources :working_lists, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Works  #
  ############
  resources :works, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Tasks  #
  ############
  resources :tasks, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  #############
  #   Hebdos  #
  #############
  resources :hebdos, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "grille_hebdos", to: "hebdos#grille"


  ###################
  #   Productions   #
  ###################
  resources :productions
  resources :prod_units
  resources :prod_destinations
  resources :traceurs


  
  ######## TESTS
  get "show.pdf", to: "export#show"
  get "test", to: "test#index"


  ########## Export DB
  #get "exports", to: "export#index"
  get "logbook_articles_json", to: "export#logbook_articles_json"

end

app/models/prod_destination.rb
class ProdDestination < ApplicationRecord
    validates :name, presence: true
    validates :name, uniqueness: true
    has_many :production, dependent: :destroy
end

app/controllers/prod_destinations_controller.rb
class ProdDestinationsController < ApplicationController
  before_action :set_prod_destination, only: %i[ show edit update destroy ]

  # GET /prod_destinations or /prod_destinations.json
  def index
    @prod_destinations = ProdDestination.all
  end

  # GET /prod_destinations/1 or /prod_destinations/1.json
  def show
  end

  # GET /prod_destinations/new
  def new
    @prod_destination = ProdDestination.new
  end

  # GET /prod_destinations/1/edit
  def edit
  end

  # POST /prod_destinations or /prod_destinations.json
  def create
    @prod_destination = ProdDestination.new(prod_destination_params)

    respond_to do |format|
      if @prod_destination.save
        format.html { redirect_to prod_destinations_url(), notice: "Prod destination was successfully created." }
        format.json { render :show, status: :created, location: @prod_destination }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @prod_destination.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /prod_destinations/1 or /prod_destinations/1.json
  def update
    respond_to do |format|
      if @prod_destination.update(prod_destination_params)
        format.html { redirect_to prod_destinations_url(), notice: "Prod destination was successfully updated." }
        format.json { render :show, status: :ok, location: @prod_destination }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @prod_destination.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /prod_destinations/1 or /prod_destinations/1.json
  def destroy
    @prod_destination.destroy

    respond_to do |format|
      format.html { redirect_to prod_destinations_url, notice: "Prod destination was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_prod_destination
      @prod_destination = ProdDestination.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def prod_destination_params
      params.require(:prod_destination).permit(:name)
    end
end

app/helpers/prod_destinations_helper.rb
module ProdDestinationsHelper
end

app/views/prod_destinations/_form.html.erb
<%= form_with(model: prod_destination) do |form| %>
  <% if prod_destination.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(prod_destination.errors.count, "error") %> prohibited this prod_destination from being saved:</h2>

      <ul>
        <% prod_destination.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>

  <br />

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/prod_destinations/_prod_destination.html.erb
<table>
  <tr>
    <td>
      <h3><%= prod_destination.name %></h3>
      <br />
    </td>
    <td>
      <div class="btn-group">
        <%= link_to "Edit", edit_prod_destination_path(prod_destination), class: "btn btn-xs btn-warning" %>
        <%= link_to "Delete", prod_destination, 
            method: :delete, 
            class: "btn btn-xs btn-danger",
            remote: true,
            data: { confirm: "Delete #{prod_destination.name} ?" }
          %>
      </div>
    </td>
  </tr>
</table>

app/views/prod_destinations/edit.html.erb
<div class="container"><h1>Editing prod destination</h1>

<%= render "form", prod_destination: @prod_destination %>

<br>

<div>
  <%= link_to "Back to prod destinations", prod_destinations_path %>
</div>
</div>

app/views/prod_destinations/index.html.erb
<div class="container">

  <h1>
    <span class="label label-default">
      <i class="material-icons">contact_mail</i>
      Destinations
    </span>
  </h1>
  
  <br />

  <div class="row">
  <%= render partial: "/home/barre_menu_production" %>
  </div>

  <br />

  <p><%= link_to "+", new_prod_destination_path, class: "btn btn-success" %></p>

  <div id="prod_destinations" class="row">
    <% @prod_destinations.each do |prod_destination| %>
      <div class="panel panel-default col-xs-4 col-sm-3" id="<%= dom_id prod_destination %>">
        <div class="panel-body">
          <%= render prod_destination %>
        </div>
      </div>
    <% end %>
  </div>

  <p><%= link_to "+", new_prod_destination_path, class: "btn btn-success" %></p>

</div>

app/views/prod_destinations/new.html.erb
<div class="container"><h1>New prod destination</h1>

<%= render "form", prod_destination: @prod_destination %>

<br>

<div>
  <%= link_to "Back to prod destinations", prod_destinations_path %>
</div>
</div>

app/views/prod_destinations/show.html.erb
<div class="container"><p style="color: green"><%= notice %></p>

<%= render @prod_destination %>

<div>
  <%= link_to "Edit this prod destination", edit_prod_destination_path(@prod_destination) %> |
  <%= link_to "Back to prod destinations", prod_destinations_path %>

  <%= button_to "Destroy this prod destination", @prod_destination, method: :delete %>
</div>
</div>